package cn.iocoder.yudao.module.delivery.controller.admin;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.module.delivery.entity.SalesReportReq;
import cn.iocoder.yudao.module.delivery.entity.SalesReportResp;
import cn.iocoder.yudao.module.delivery.service.SalesReportService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

import static cn.iocoder.yudao.framework.common.pojo.CommonResult.success;

/**
 * (Employee)表控制层
 *
 * @author lanbm
 * @since 2024-03-27 21:25:55
 */
@RestController
@Api(tags = "管理后台 -统计报表")
@RequestMapping("/Report/SalesReport")
public class SalesReportControl {

    //ecw_order_departure 订单始发地
    //ecw_order_consignor 订单发货人
    //ecw_order_consignee 订单收货人

    //订单表 ecw_order
    //drawee 付款人 付款人：1 发货人 2 收货人 3 自定义
    //status 订单状态 0草稿 2待入仓，3入参中

    @Autowired
    private SalesReportService salesReportService;

    /*
     首次成交的客户数统计
     lanbm 2024-04-01
     */
    @PostMapping("/FirstCustomerCount")
    public CommonResult<Integer> FirstCustomerCount(@RequestBody SalesReportReq Req) {
        int nR=salesReportService.FirstCustomerCount(Req);
        return success(nR);
    }

    /*
    按运输方式统计重量和方数
    lanbm 2024-04-01
    */
    @PostMapping("/SalesReportCount")
    public CommonResult<SalesReportResp> SalesReportCount(@RequestBody SalesReportReq Req) {
        String s="";
        SalesReportResp re=salesReportService.SalesReportCount(Req);
        return success(re);
    }

    /*
     图表分析统计结果
     lanbm 2024-04-01 add
     */
    @PostMapping("/SalesReportList")
    public CommonResult<Integer> SalesReportList(@RequestBody SalesReportReq Req) {
        int nR=salesReportService.FirstCustomerCount(Req);
        return success(nR);
    }




}
