package cn.iocoder.yudao.module.delivery.service.Impl;

import cn.iocoder.yudao.framework.common.pojo.CommonResult;
import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.i18n.core.I18nMessage;
import cn.iocoder.yudao.framework.mybatis.core.util.MyBatisUtils;
import cn.iocoder.yudao.framework.mybatis.core.vo.PageVO;
import cn.iocoder.yudao.framework.redis.helper.RedisHelper;
import cn.iocoder.yudao.module.delivery.entity.CustomerAnalysisReq;
import cn.iocoder.yudao.module.delivery.entity.CustomerAnalysisResp;
import cn.iocoder.yudao.module.delivery.entity.CustomerAnalysisExcelResp;
import cn.iocoder.yudao.module.delivery.entity.CustomerReportReq;
import cn.iocoder.yudao.module.delivery.mapper.CustomerAnalysisMapper;
import cn.iocoder.yudao.module.delivery.service.CustomerAnalysisService;
import cn.iocoder.yudao.module.delivery.service.CustomerReportService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.stream.Collectors;

/*
 lanbm 2024-04-01 add
 客户分析列表
 */
@Service("CustomerAnalysisService")
public class CustomerAnalysisImpl implements CustomerAnalysisService {

    @Autowired
    private CustomerAnalysisMapper customerAnalysisMapper;

    @Resource
    private RedisHelper redisHelper;

    public List<CustomerAnalysisExcelResp> getList(CustomerAnalysisReq req) {
        return customerAnalysisMapper.getList(req);
    }


    public PageResult<CustomerAnalysisResp> getListPage(CustomerAnalysisReq req)
            throws JsonProcessingException {

        IPage<CustomerAnalysisResp> mpPage = MyBatisUtils.buildPage(req);
        long total = customerAnalysisMapper.GetCount(req);
        System.out.println("符合条件的客户总数：" + String.valueOf(total));
        int start = (req.getPageNo() - 1) * req.getPageSize();
        int size = req.getPageSize();

        req.setSize(size);
        req.setStart(start);

        /*
        List<CustomerAnalysisResp> list = null;
        String sList = redisHelper.get("CustomerAnalysisRespList");
        if (sList == null || sList.length() == 0) {
            list = customerAnalysisMapper.getListPage(req);
            ObjectMapper objectMapper = new ObjectMapper();
            // 将List转换为JSON字符串
            String json = objectMapper.writeValueAsString(list);
            redisHelper.set("CustomerAnalysisRespList", json);
        } else {
            list = JSON.parseArray(sList, CustomerAnalysisResp.class);
        }
        */
        List<CustomerAnalysisResp> list = customerAnalysisMapper.getListPage(req);
        return new PageResult<>(list, total, mpPage.getSize(),
                req.getPageNo(), (total + mpPage.getSize() - 1) / mpPage.getSize());

    }


    private List<CustomerAnalysisResp> GetPageResult(
            List<CustomerAnalysisResp> list, int pageNum, int pageSize) {
        /*
        // 正序
        Collections.sort(list, (a, b) -> {
            return a.排序字段 - b.排序字段;
        });
        // 倒序
        Collections.sort(list, (a, b) -> {
            return b.排序字段 - a.排序字段;
        });*/
        // 总数
        int total = list.size();

        // 分页数据
        List<CustomerAnalysisResp> subList =
                list.stream().skip((pageNum - 1) * pageSize).limit(pageSize).collect(Collectors.toList());
        return subList;

    }


    /*
     lanbm 2024-04-26 add
     */
    public PageResult<CustomerAnalysisResp> getListPage_New(CustomerAnalysisReq req)
            throws JsonProcessingException {
        List<CustomerAnalysisResp> list = customerAnalysisMapper.getListPage_New(req);
        long  total=list.size();
        list = GetPageResult(list, req.getPageNo(), req.getPageSize());
        return new PageResult<>(list, total, req.getPageSize(),
                req.getPageNo(),
                (total + req.getPageSize() - 1) / req.getPageSize());

    }

}
